Loading...
Searching...
No Matches
casacore::Adios2StManColumnT< T > Class Template Reference

`#include <Adios2StManColumn.h>`

## Public Member Functions

void | create (std::shared_ptr< adios2::Engine > aAdiosEngine, char aOpenMode)
| Adios2StManColumn (Adios2StMan::impl *aParent, int aDataType, String aColName, std::shared_ptr< adios2::IO > aAdiosIO)
Public Member Functions inherited from casacore::Adios2StManColumn
| Adios2StManColumn (Adios2StMan::impl *aParent, int aDataType, String aColName, std::shared_ptr< adios2::IO > aAdiosIO)
virtual void | setShapeColumn (const IPosition &aShape) override
| Set the shape of all (fixed-shaped) arrays in the column.
virtual IPosition | shape (rownr_t aRowNr) override
| Get the shape of the item in the given row.
Bool | canChangeShape () const override
| Can the data manager handle chaging the shape of an existing array?
void | setShape (rownr_t aRowNr, const IPosition &aShape) override
| Set the shape of an (variable-shaped) array in the given row.
int | getDataTypeSize ()
int | getDataType ()
String | getColumnName ()
Public Member Functions inherited from casacore::StManColumnBase
| StManColumnBase (int dataType)
| Default constructor.
| ~StManColumnBase ()
| StManColumnBase (const StManColumnBase &)=delete
| The object cannot be copied.
StManColumnBase & | operator= (const StManColumnBase &)=delete
| The object cannot be assigned to.
virtual int | dataType () const
| Return the data type of the column.
DataType | dtype () const
Int | elemSize () const
| Return the size of an element of the column's data type.
Public Member Functions inherited from casacore::DataManagerColumn
| DataManagerColumn ()
| Create a column.
virtual | ~DataManagerColumn ()
| Frees up the storage.
| DataManagerColumn (const DataManagerColumn &)=delete
| The copy constructor cannot be used for this base class.
DataManagerColumn & | operator= (const DataManagerColumn &)=delete
| Assignment cannot be used for this base class.
void | setIsFixedShape (Bool isFixedShape)
| Set the isFixedShape flag.
Bool | isFixedShape () const
| Is this a fixed shape column?
virtual String | dataTypeId () const
| Get the data type id of the column for dataType==TpOther.
virtual Bool | isWritable () const
| Test if data can be put into this column.
virtual void | setMaxLength (uInt maxLength)
| Set the maximum length of the value (can be used for strings).
void | setFixedShapeColumn (const IPosition &shape)
| Set the shape of all (fixed-shaped) arrays in the column.
virtual void | setShapeTiled (rownr_t rownr, const IPosition &shape, const IPosition &tileShape)
| Set the shape and tile shape of an (variable-shaped) array in the given row.
virtual Bool | isShapeDefined (rownr_t rownr)
| Is the value shape defined in the given row?
virtual uInt | ndim (rownr_t rownr)
| Get the dimensionality of the item in the given row.
virtual IPosition | tileShape (rownr_t rownr)
| Get the tile shape of the item in the given row.
ColumnCache & | columnCache ()
| Get access to the ColumnCache object.
const ColumnCache * | columnCachePtr () const
void | get (rownr_t rownr, Bool *dataPtr)
| Get the scalar value in the given row.
void | get (rownr_t rownr, uChar *dataPtr)
void | get (rownr_t rownr, Short *dataPtr)
void | get (rownr_t rownr, uShort *dataPtr)
void | get (rownr_t rownr, Int *dataPtr)
void | get (rownr_t rownr, uInt *dataPtr)
void | get (rownr_t rownr, Int64 *dataPtr)
void | get (rownr_t rownr, float *dataPtr)
void | get (rownr_t rownr, double *dataPtr)
void | get (rownr_t rownr, Complex *dataPtr)
void | get (rownr_t rownr, DComplex *dataPtr)
void | get (rownr_t rownr, String *dataPtr)
void | get (rownr_t rownr, void *dataPtr)
| This function is the get for all non-standard data types.
void | put (rownr_t rownr, const Bool *dataPtr)
| Put the scalar value into the given row.
void | put (rownr_t rownr, const uChar *dataPtr)
void | put (rownr_t rownr, const Short *dataPtr)
void | put (rownr_t rownr, const uShort *dataPtr)
void | put (rownr_t rownr, const Int *dataPtr)
void | put (rownr_t rownr, const uInt *dataPtr)
void | put (rownr_t rownr, const Int64 *dataPtr)
void | put (rownr_t rownr, const float *dataPtr)
void | put (rownr_t rownr, const double *dataPtr)
void | put (rownr_t rownr, const Complex *dataPtr)
void | put (rownr_t rownr, const DComplex *dataPtr)
void | put (rownr_t rownr, const String *dataPtr)
void | put (rownr_t rownr, const void *dataPtr)
| This function is the put for all non-standard data types.
void | throwGet () const
| Throw an "invalid operation" exception for the default implementation of get.
void | throwPut () const
| Throw an "invalid operation" exception for the default implementation of put.
void | setColumnName (const String &colName)
| Set the column name.
const String & | columnName () const
| Get rhe column name.

## Private Member Functions

void | toAdios (const void *data, std::size_t offset)
void | fromAdios (void *data, std::size_t offset)
void | toAdios (const ArrayBase *arrayPtr)
void | fromAdios (ArrayBase *arrayPtr)

## Private Attributes

adios2::Variable< T > | itsAdiosVariable

## Additional Inherited Members

Static Public Member Functions inherited from casacore::StManColumnBase
static Bool | isNativeDataType (int dtype)
| Test if the given data type is supported by storage managers.
Protected Member Functions inherited from casacore::Adios2StManColumn
virtual void | getBool (rownr_t aRowNr, Bool *aDataPtr) override
| scalar get/put
virtual void | getuChar (rownr_t aRowNr, uChar *aDataPtr) override
virtual void | getShort (rownr_t aRowNr, Short *aDataPtr) override
virtual void | getuShort (rownr_t aRowNr, uShort *aDataPtr) override
virtual void | getInt (rownr_t aRowNr, Int *aDataPtr) override
virtual void | getuInt (rownr_t aRowNr, uInt *aDataPtr) override
virtual void | getInt64 (rownr_t aRowNr, Int64 *aDataPtr) override
virtual void | getfloat (rownr_t aRowNr, Float *aDataPtr) override
virtual void | getdouble (rownr_t aRowNr, Double *aDataPtr) override
virtual void | getComplex (rownr_t aRowNr, Complex *aDataPtr) override
virtual void | getDComplex (rownr_t aRowNr, DComplex *aDataPtr) override
virtual void | getString (rownr_t aRowNr, String *aDataPtr) override
virtual void | putBool (rownr_t aRowNr, const Bool *aDataPtr) override
| Put the scalar value into the given row.
virtual void | putuChar (rownr_t aRowNr, const uChar *aDataPtr) override
virtual void | putShort (rownr_t aRowNr, const Short *aDataPtr) override
virtual void | putuShort (rownr_t aRowNr, const uShort *aDataPtr) override
virtual void | putInt (rownr_t aRowNr, const Int *aDataPtr) override
virtual void | putuInt (rownr_t aRowNr, const uInt *aDataPtr) override
virtual void | putInt64 (rownr_t aRowNr, const Int64 *aDataPtr) override
virtual void | putfloat (rownr_t aRowNr, const Float *aDataPtr) override
virtual void | putdouble (rownr_t aRowNr, const Double *aDataPtr) override
virtual void | putComplex (rownr_t aRowNr, const Complex *aDataPtr) override
virtual void | putDComplex (rownr_t aRowNr, const DComplex *aDataPtr) override
virtual void | putString (rownr_t aRowNr, const String *aDataPtr) override
virtual void | getScalarColumnV (ArrayBase &dataPtr) override
| The rest of the get and put functions.
virtual void | putScalarColumnV (const ArrayBase &dataPtr) override
| Put all scalar values in the column.
virtual void | getScalarColumnCellsV (const RefRows &rownrs, ArrayBase &dataPtr) override
| Get some scalar values in the column.
virtual void | putScalarColumnCellsV (const RefRows &rownrs, const ArrayBase &dataPtr) override
| Put some scalar values in the column.
virtual void | getArrayV (rownr_t rownr, ArrayBase &dataPtr) override
| Get the array value in the given row.
virtual void | putArrayV (rownr_t rownr, const ArrayBase &data) override
| Put the array value into the given row.
virtual void | getArrayColumnV (ArrayBase &data) override
| Get all array values in the column.
virtual void | putArrayColumnV (const ArrayBase &data) override
| Put all array values in the column.
virtual void | getArrayColumnCellsV (const RefRows &rownrs, ArrayBase &data) override
| Get some array values in the column.
virtual void | putArrayColumnCellsV (const RefRows &rownrs, const ArrayBase &data) override
| Put some array values in the column.
virtual void | getSliceV (rownr_t rownr, const Slicer &slicer, ArrayBase &data) override
| Get a section of the array in the given row.
virtual void | putSliceV (rownr_t rownr, const Slicer &slicer, const ArrayBase &data) override
| Put into a section of the array in the given row.
virtual void | getColumnSliceV (const Slicer &slicer, ArrayBase &data) override
| Get a section of all arrays in the column.
virtual void | putColumnSliceV (const Slicer &slicer, const ArrayBase &data) override
| Put into a section of all arrays in the column.
virtual void | getColumnSliceCellsV (const RefRows &rownrs, const Slicer &slicer, ArrayBase &data) override
| Get a section of some arrays in the column.
virtual void | putColumnSliceCellsV (const RefRows &rownrs, const Slicer &slicer, const ArrayBase &data) override
| Put into a section of some arrays in the column.
void | scalarToSelection (rownr_t rownr)
void | scalarColumnVToSelection ()
void | scalarColumnCellsVToSelection (const RefRows &rownrs)
void | arrayVToSelection (rownr_t rownr)
void | arrayColumnVToSelection ()
void | sliceVToSelection (rownr_t rownr, const Slicer &ns)
void | columnSliceVToSelection (const Slicer &ns)
void | columnSliceCellsVToSelection (const RefRows &rows, const Slicer &ns)
void | columnSliceCellsVToSelection (rownr_t row_start, rownr_t row_end, const Slicer &ns)
Protected Member Functions inherited from casacore::DataManagerColumn
virtual void | getOther (rownr_t rownr, void *dataPtr)
| This function is the get for all non-standard data types.
virtual void | putOther (rownr_t rownr, const void *dataPtr)
| This function is the put for all non-standard data types.
void | getScalarColumnBase (ArrayBase &dataPtr)
| The default implementations of get and put functions.
void | putScalarColumnBase (const ArrayBase &dataPtr)
void | getScalarColumnCellsBase (const RefRows &rownrs, ArrayBase &dataPtr)
void | putScalarColumnCellsBase (const RefRows &rownrs, const ArrayBase &dataPtr)
void | getArrayColumnBase (ArrayBase &data)
void | putArrayColumnBase (const ArrayBase &data)
void | getArrayColumnCellsBase (const RefRows &rownrs, ArrayBase &data)
void | putArrayColumnCellsBase (const RefRows &rownrs, const ArrayBase &data)
void | getSliceBase (rownr_t rownr, const Slicer &slicer, ArrayBase &data)
void | putSliceBase (rownr_t rownr, const Slicer &slicer, const ArrayBase &data)
void | getColumnSliceBase (const Slicer &slicer, ArrayBase &data)
void | putColumnSliceBase (const Slicer &slicer, const ArrayBase &data)
void | getColumnSliceCellsBase (const RefRows &rownrs, const Slicer &slicer, ArrayBase &data)
void | putColumnSliceCellsBase (const RefRows &rownrs, const Slicer &slicer, const ArrayBase &data)
Protected Attributes inherited from casacore::Adios2StManColumn
Adios2StMan::impl * | itsStManPtr
String | itsColumnName
IPosition | itsCasaShape
std::unordered_map< rownr_t, IPosition > | itsCasaShapes
Bool | isShapeFixed
std::shared_ptr< adios2::IO > | itsAdiosIO
std::shared_ptr< adios2::Engine > | itsAdiosEngine
std::string | itsAdiosDataType
adios2::Dims | itsAdiosShape
adios2::Dims | itsAdiosStart
adios2::Dims | itsAdiosCount

## Detailed Description

template<class T>
class casacore::Adios2StManColumnT< T >

Definition at line 173 of file Adios2StManColumn.h.

## Member Function Documentation

## Adios2StManColumn()

template<class T>

casacore::Adios2StManColumn::Adios2StManColumn | ( | Adios2StMan::impl * | aParent,
|  | int | aDataType,
|  | String | aColName,
|  | std::shared_ptr< adios2::IO > | aAdiosIO )

## create()

template<class T>

void casacore::Adios2StManColumnT< T >::create | ( | std::shared_ptr< adios2::Engine > | aAdiosEngine,
|  | char | aOpenMode )

inline virtual

Implements casacore::Adios2StManColumn.

Definition at line 179 of file Adios2StManColumn.h.

References casacore::Adios2StManColumn::itsAdiosCount, casacore::Adios2StManColumn::itsAdiosEngine, casacore::Adios2StManColumn::itsAdiosIO, casacore::Adios2StManColumn::itsAdiosShape, casacore::Adios2StManColumn::itsAdiosStart, itsAdiosVariable, and casacore::Adios2StManColumn::itsColumnName.

## fromAdios() [1/2]

template<class T>

void casacore::Adios2StManColumnT< T >::fromAdios | ( | ArrayBase * | arrayPtr | ) |

inline private virtual

Implements casacore::Adios2StManColumn.

Definition at line 220 of file Adios2StManColumn.h.

References fromAdios(), casacore::ArrayBase::getVStorage(), and casacore::ArrayBase::putVStorage().

## fromAdios() [2/2]

template<class T>

void casacore::Adios2StManColumnT< T >::fromAdios | ( | void * | data,
|  | std::size_t | offset )

inline private virtual

Implements casacore::Adios2StManColumn.

Definition at line 205 of file Adios2StManColumn.h.

References casacore::Adios2StManColumn::itsAdiosCount, casacore::Adios2StManColumn::itsAdiosEngine, casacore::Adios2StManColumn::itsAdiosStart, itsAdiosVariable, and casacore::offset().

Referenced by fromAdios().

## toAdios() [1/2]

template<class T>

void casacore::Adios2StManColumnT< T >::toAdios | ( | const ArrayBase * | arrayPtr | ) |

inline private virtual

Implements casacore::Adios2StManColumn.

Definition at line 212 of file Adios2StManColumn.h.

References casacore::ArrayBase::freeVStorage(), casacore::ArrayBase::getVStorage(), and toAdios().

## toAdios() [2/2]

template<class T>

void casacore::Adios2StManColumnT< T >::toAdios | ( | const void * | data,
|  | std::size_t | offset )

inline private virtual

Implements casacore::Adios2StManColumn.

Definition at line 196 of file Adios2StManColumn.h.

References casacore::Adios2StManColumn::isShapeFixed, casacore::Adios2StManColumn::itsAdiosCount, casacore::Adios2StManColumn::itsAdiosEngine, casacore::Adios2StManColumn::itsAdiosShape, casacore::Adios2StManColumn::itsAdiosStart, itsAdiosVariable, and casacore::offset().

Referenced by toAdios().

## Member Data Documentation

## itsAdiosVariable

template<class T>

adios2::Variable<T> casacore::Adios2StManColumnT< T >::itsAdiosVariable

private

Definition at line 194 of file Adios2StManColumn.h.

Referenced by create(), fromAdios(), and toAdios().

The documentation for this class was generated from the following file:

- tables/DataMan/Adios2StManColumn.h